KDE 4.9 PyKDE API Reference

- KDE's Python API

# KReplace Class Reference

`from PyKDE4.kdeui import *`

Inherits: KFind → QObject

## Detailed Description

A generic implementation of the "replace" function.

Author:
  S.R.Haque <srhaque@iee.org>, David Faure <faure@kde.org>

Detail:

This class includes prompt handling etc. Also provides some static functions which can be used to create custom behavior instead of using the class directly.

Example:

To use the class to implement a complete replace feature:

In the slot connect to the replace action, after using KReplaceDialog:

      // This creates a replace-on-prompt dialog if needed.
      m_replace = new KReplace(pattern, replacement, options, this);

      // Connect signals to code which handles highlighting
      // of found text, and on-the-fly replacement.
      connect( m_replace, SIGNAL( highlight( const QString &, int, int ) ),
              this, SLOT( slotHighlight( const QString &, int, int ) ) );
      // Connect findNext signal - called when pressing the button in the dialog
      connect( m_replace, SIGNAL( findNext() ),
              this, SLOT( slotReplaceNext() ) );
      // Connect replace signal - called when doing a replacement
      connect( m_replace, SIGNAL( replace(const QString &, int, int, int) ),
              this, SLOT( slotReplace(const QString &, int, int, int) ) );

Then initialize the variables determining the "current position" (to the cursor, if the option FromCursor is set, to the beginning of the selection if the option SelectedText is set, and to the beginning of the document otherwise). Initialize the "end of search" variables as well (end of doc or end of selection). Swap begin and end if FindBackwards. Finally, call slotReplaceNext();

      void slotReplaceNext()
      {
          KFind.Result res = KFind.NoMatch;
          while ( res == KFind.NoMatch && <position not at end> ) {
              if ( m_replace->needData() )
                  m_replace->setData( <current text fragment> );

              // Let KReplace inspect the text fragment, and display a dialog if a match is found
              res = m_replace->replace();

              if ( res == KFind.NoMatch ) {
                  <Move to the next text fragment, honoring the FindBackwards setting for the direction>
              }
          }

          if ( res == KFind.NoMatch ) // i.e. at end
              <Call either  m_replace->displayFinalDialog(); delete m_replace; m_replace = 0L;
               or           if ( m_replace->shouldRestart() ) { reinit (w/o FromCursor) and call slotReplaceNext(); }
                            else { m_replace->closeReplaceNextDialog(); }>
      }

Don't forget delete m_find in the destructor of your class, unless you gave it a parent widget on construction.

## Signals

| replace (QString text, int replacementIndex, int replacedLength, int matchedLength)

## Methods

| __init__ (self, QString pattern, QString replacement, long options, QWidget parent=0)
| __init__ (self, QString pattern, QString replacement, long options, QWidget parent, QWidget replaceDialog)
| closeReplaceNextDialog (self)
| displayFinalDialog (self)
int | numReplacements (self)
KFind.Result | replace (self)
KDialog | replaceNextDialog (self, bool create=0)
| resetCounts (self)
bool | shouldRestart (self, bool forceAsking=0, bool showNumMatches=1)

## Static Methods

int, int replacedLength | replace (QString text, QString pattern, QString replacement, int index, long options)
int, int replacedLength | replace (QString text, QRegExp pattern, QString replacement, int index, long options)

## Signal Documentation

replace | ( | QString | text,
|  | int | replacementIndex,
|  | int | replacedLength,
|  | int | matchedLength
| ) |  |  |

Connect to this slot to implement updating of replaced text during the replace operation.

Extra care must be taken to properly implement the "no prompt-on-replace" case. For instance highlight isn't emitted in that case (some code might rely on it), and for performance reasons one should repaint after replace() ONLY if prompt-on-replace was selected.

Parameters:

  | text | The text, in which the replacement has already been done.
  | replacementIndex | Starting index of the matched substring
  | replacedLength | Length of the replacement string
  | matchedLength | Length of the matched string

Signal syntax:
  `QObject.connect(source, SIGNAL("replace(const QString&, int, int, int)"), target_slot)`

## Method Documentation

__init__ | ( | self, |
|  | QString | pattern,
|  | QString | replacement,
|  | long | options,
|  | QWidget | parent=0
| ) |  |  |

Only use this constructor if you don't use KFindDialog, or if you use it as a modal dialog.

__init__ | ( | self, |
|  | QString | pattern,
|  | QString | replacement,
|  | long | options,
|  | QWidget | parent,
|  | QWidget | replaceDialog
| ) |  |  |

This is the recommended constructor if you also use KReplaceDialog (non-modal). You should pass the pointer to it here, so that when a message box appears it has the right parent. Don't worry about deletion, KReplace will notice if the find dialog is closed.

closeReplaceNextDialog | ( |  | self ) |

Close the "replace next?" dialog. The application should do this when the last match was hit. If the application deletes the KReplace, then "find previous" won't be possible anymore.

displayFinalDialog | ( |  | self ) |

Displays the final dialog telling the user how many replacements were made. Call either this or shouldRestart().

int numReplacements | ( |  | self ) |

Return the number of replacements made (i.e. the number of times the replace signal was emitted). Can be used in a dialog box to tell the user how many replacements were made. The final dialog does so already, unless you used setDisplayFinalDialog(false).

KFind.Result replace | ( |  | self ) |

Connect to this slot to implement updating of replaced text during the replace operation.

Extra care must be taken to properly implement the "no prompt-on-replace" case. For instance highlight isn't emitted in that case (some code might rely on it), and for performance reasons one should repaint after replace() ONLY if prompt-on-replace was selected.

Parameters:

  | text | The text, in which the replacement has already been done.
  | replacementIndex | Starting index of the matched substring
  | replacedLength | Length of the replacement string
  | matchedLength | Length of the matched string

KDialog replaceNextDialog | ( | self, |
|  | bool | create=0
| ) |  |  |

Return (or create) the dialog that shows the "find next?" prompt. Usually you don't need to call this. One case where it can be useful, is when the user selects the "Find" menu item while a find operation is under way. In that case, the program may want to call setActiveWindow() on that dialog.

resetCounts | ( |  | self ) |

Call this to reset the numMatches & numReplacements counts. Can be useful if reusing the same KReplace for different operations, or when restarting from the beginning of the document.

bool shouldRestart | ( | self, |
|  | bool | forceAsking=0,
|  | bool | showNumMatches=1
| ) |  |  |

Returns true if we should restart the search from scratch. Can ask the user, or return false (if we already searched/replaced the whole document without the PromptOnReplace option).

Parameters:

  | forceAsking | set to true if the user modified the document during the search. In that case it makes sense to restart the search again.
  | showNumMatches | set to true if the dialog should show the number of matches. Set to false if the application provides a "find previous" action, in which case the match count will be erroneous when hitting the end, and we could even be hitting the beginning of the document (so not all matches have even been seen).

## Static Method Documentation

int, int replacedLength replace | ( | QString | text,
|  | QString | pattern,
|  | QString | replacement,
|  | int | index,
|  | long | options
| ) |  |  |

Connect to this slot to implement updating of replaced text during the replace operation.

Extra care must be taken to properly implement the "no prompt-on-replace" case. For instance highlight isn't emitted in that case (some code might rely on it), and for performance reasons one should repaint after replace() ONLY if prompt-on-replace was selected.

Parameters:

  | text | The text, in which the replacement has already been done.
  | replacementIndex | Starting index of the matched substring
  | replacedLength | Length of the replacement string
  | matchedLength | Length of the matched string

int, int replacedLength replace | ( | QString | text,
|  | QRegExp | pattern,
|  | QString | replacement,
|  | int | index,
|  | long | options
| ) |  |  |

Connect to this slot to implement updating of replaced text during the replace operation.

Extra care must be taken to properly implement the "no prompt-on-replace" case. For instance highlight isn't emitted in that case (some code might rely on it), and for performance reasons one should repaint after replace() ONLY if prompt-on-replace was selected.

Parameters:

  | text | The text, in which the replacement has already been done.
  | replacementIndex | Starting index of the matched substring
  | replacedLength | Length of the replacement string
  | matchedLength | Length of the matched string